/// <reference path="./defs/vue.d.ts" />

class SampleVueModel {
    //メッセージ部分用
    message:string = "hello vue";
    count:number = 0;

    //TODO用
    todos:any[] = [];
    editingTodoMessage:string = '';

    countUp(){
        this.count++;
    }

    resetTodos(){
        this.todos = [];
    }

    addTodo(todoMessage:string){
        this.todos.push({
            text: todoMessage
        });
    }

    removeTodo(index:number){
        if(index + 1 > this.todos.length){
            console.log('index error');
            return;
        }
        this.todos.splice(index, 1);
    }
}

export default class SampleVueController{
    appVue:any;
    el:string = "#app";
    model:SampleVueModel;

    constructor(){
        this.model = new SampleVueModel();
        this.appVue = new Vue({
            el:this.el,
            data: this.model,
            methods:{
                changeMessage:(e)=>{ this.changeMessage(e); },
                addTodo:(e)=>{ this.addTodo(e); },
                removeTodo:(index, e)=>{ this.removeTodo(index, e);}
            }
        });
    }

    changeMessage(e){
        this.model.message = "hello vue " + this.model.count;
        this.model.countUp();
    }

    addTodo(e){
        this.model.addTodo(this.model.editingTodoMessage);
    }

    removeTodo(index, e){
        this.model.removeTodo(index);
    }
}
